﻿namespace HeuristicLab.Algorithms.PushGP.Data.Random {
  using System;
  using System.Threading;

  using HeuristicLab.Core;
  using HeuristicLab.Random;

  public class RandomFactory {
    public static readonly RandomFactory Instance = new RandomFactory();

    static RandomFactory() {
      Seed = Environment.TickCount;
    }

    public static int Seed;

    public static ThreadLocal<IRandom> GetRandom() {
      return new ThreadLocal<IRandom>(() => new FastRandom(Seed/*Interlocked.Increment(ref Seed)*/));
    }
  }
}
